Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
ButtonEventList Class Reference

Records a set of button events that happened recently. More...

`#include "buttonEventList.h"`

Inheritance diagram for ButtonEventList:

## Public Member Functions
| ButtonEventList (const ButtonEventList &copy)
void | add_event (ButtonEvent event)
| Adds a new event to the end of the list.
void | add_events (const ButtonEventList &other)
| Appends the events from the other list onto the end of this one.
void | clear ()
| Empties all the events from the list.
void | fillin (DatagramIterator &scan, BamReader *manager)
| This internal function is called by make_from_bam to read in all of the relevant data from the BamFile for the new ButtonEventList.
virtual TypeHandle | force_init_type ()
const ButtonEvent & | get_event (int n) const
int | get_num_events () const
virtual TypeHandle | get_type () const
void | operator= (const ButtonEventList &copy)
virtual void | output (std::ostream &out) const
void | update_mods (ModifierButtons &mods) const
| Updates the indicated ModifierButtons object with all of the button up/down transitions indicated in the list.
void | write (std::ostream &out, int indent_level=0) const
virtual void | write_datagram (BamWriter *manager, Datagram &dg)
| Writes the contents of this object to the datagram for shipping out to a Bam file.
Public Member Functions inherited from ParamValueBase
virtual TypeHandle | get_value_type () const
| Returns the type of the underlying value.
Public Member Functions inherited from TypedWritableReferenceCount
| TypedWritableReferenceCount (const TypedWritableReferenceCount &copy)
virtual ReferenceCount * | as_reference_count ()
| Returns the pointer cast to a ReferenceCount pointer, if it is in fact of that type.
void | operator= (const TypedWritableReferenceCount &copy)
Public Member Functions inherited from TypedWritable
| TypedWritable (const TypedWritable &copy)
virtual int | complete_pointers (TypedWritable **p_list, BamReader *manager)
| Receives an array of pointers, one for each time manager->read_pointer() was called in fillin().
vector_uchar | encode_to_bam_stream () const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and returns that data as a bytes object.
bool | encode_to_bam_stream (vector_uchar &data, BamWriter *writer=nullptr) const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and stores that data in the indicated string.
virtual void | finalize (BamReader *manager)
| Called by the BamReader to perform any final actions needed for setting up the object after all objects have been read and all pointers have been completed.
UpdateSeq | get_bam_modified () const
| Returns the current bam_modified counter.
void | mark_bam_modified ()
| Increments the bam_modified counter, so that this object will be invalidated and retransmitted on any open bam streams.
void | operator= (const TypedWritable &copy)
virtual bool | require_fully_complete () const
| Some objects require all of their nested pointers to have been completed before the objects themselves can be completed.
virtual void | update_bam_nested (BamWriter *manager)
| Called by the BamWriter when this object has not itself been modified recently, but it should check its nested objects for updates.
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
static void | register_with_read_factory ()
| Tells the BamReader how to create objects of type Lens.
Static Public Member Functions inherited from ParamValueBase
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedWritableReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
static | PT (TypedWritableReferenceCount) decode_from_bam_stream(vector_uchar data
Static Public Member Functions inherited from TypedWritable
static bool | decode_raw_from_bam_stream (TypedWritable *&ptr, ReferenceCount *&ref_ptr, vector_uchar data, BamReader *reader=nullptr)
| Reads the bytes created by a previous call to encode_to_bam_stream(), and extracts the single object on those bytes.
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Public Attributes
| get_event
| Returns the nth event in the list.
| get_num_events
| Returns the number of events in the list.
Public Attributes inherited from TypedWritableReferenceCount
static BamReader * | reader = nullptr)
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.

## Additional Inherited Members
Static Public Attributes inherited from TypedWritable
static TypedWritable *const | Null = nullptr

## Detailed Description

Records a set of button events that happened recently.

This class is usually used only in the data graph, to transmit the recent button presses, but it may be used anywhere a list of ButtonEvents is desired.

Definition at line 33 of file buttonEventList.h.

## Constructor & Destructor Documentation

## ◆ ButtonEventList() [1/2]

ButtonEventList::ButtonEventList | ( |  | ) |
| inline

Definition at line 17 of file buttonEventList.I.

## ◆ ButtonEventList() [2/2]

ButtonEventList::ButtonEventList | ( | const ButtonEventList & | copy | ) |
| inline

Definition at line 24 of file buttonEventList.I.

## Member Function Documentation

## ◆ add_event()

void ButtonEventList::add_event | ( | ButtonEvent | event | ) |
| inline

Adds a new event to the end of the list.

Definition at line 41 of file buttonEventList.I.

Referenced by VirtualMouse::press_button().

## ◆ add_events()

void ButtonEventList::add_events | ( | const ButtonEventList & | other | ) |

Appends the events from the other list onto the end of this one.

Definition at line 23 of file buttonEventList.cxx.

## ◆ clear()

void ButtonEventList::clear | ( |  | ) |
| inline

Empties all the events from the list.

Definition at line 71 of file buttonEventList.I.

## ◆ fillin()

void ButtonEventList::fillin | ( | DatagramIterator & | scan,
|  | BamReader * | manager )
| virtual

This internal function is called by make_from_bam to read in all of the relevant data from the BamFile for the new ButtonEventList.

This function is normally protected, but it is declared public in this case so that MouseRecorder may call it to read a ButtonEventList from the middle of a datagram.

Reimplemented from TypedWritable.

Definition at line 124 of file buttonEventList.cxx.

References TypedWritable::fillin(), DatagramIterator::get_uint16(), and ButtonEvent::read_datagram().

Referenced by MouseRecorder::play_frame().

## ◆ force_init_type()

virtual TypeHandle ButtonEventList::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from ParamValueBase.

Definition at line 78 of file buttonEventList.h.

## ◆ get_class_type()

static TypeHandle ButtonEventList::get_class_type | ( |  | ) |
| inline static

Definition at line 67 of file buttonEventList.h.

## ◆ get_type()

virtual TypeHandle ButtonEventList::get_type | ( |  | ) | const
| inline virtual

Reimplemented from ParamValueBase.

Definition at line 75 of file buttonEventList.h.

## ◆ init_type()

static void ButtonEventList::init_type | ( |  | ) |
| inline static

Definition at line 70 of file buttonEventList.h.

## ◆ operator=()

void ButtonEventList::operator= | ( | const ButtonEventList & | copy | ) |
| inline

Definition at line 33 of file buttonEventList.I.

## ◆ output()

void ButtonEventList::output | ( | std::ostream & | out | ) | const
| virtual

Implements ParamValueBase.

Definition at line 47 of file buttonEventList.cxx.

## ◆ register_with_read_factory()

void ButtonEventList::register_with_read_factory | ( |  | ) |
| static

Tells the BamReader how to create objects of type Lens.

Definition at line 79 of file buttonEventList.cxx.

References BamReader::get_factory(), and Factory< Type >::register_factory().

## ◆ update_mods()

void ButtonEventList::update_mods | ( | ModifierButtons & | mods | ) | const

Updates the indicated ModifierButtons object with all of the button up/down transitions indicated in the list.

Definition at line 36 of file buttonEventList.cxx.

## ◆ write()

void ButtonEventList::write | ( | std::ostream & | out,
|  | int | indent_level = 0 ) const

Definition at line 67 of file buttonEventList.cxx.

## ◆ write_datagram()

void ButtonEventList::write_datagram | ( | BamWriter * | manager,
|  | Datagram & | dg )
| virtual

Writes the contents of this object to the datagram for shipping out to a Bam file.

Reimplemented from TypedWritable.

Definition at line 88 of file buttonEventList.cxx.

References Datagram::add_uint16(), and TypedWritable::write_datagram().

## Member Data Documentation

## ◆ get_event

const ButtonEvent & ButtonEventList::get_event
| inline

Returns the nth event in the list.

This does not remove the event from the list; the only way to remove events is to empty the whole list with clear().

Definition at line 50 of file buttonEventList.h.

## ◆ get_num_events

int ButtonEventList::get_num_events
| inline

Returns the number of events in the list.

Definition at line 50 of file buttonEventList.h.

The documentation for this class was generated from the following files:

- panda/src/event/buttonEventList.h
- panda/src/event/buttonEventList.cxx
- panda/src/event/buttonEventList.I